import processing.core.*; 
import processing.xml.*; 

import simpleML.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Current62 extends PApplet {



//addauto play option
//screenshots of longer time intervals
//pre-initialize date array!



//Some variables for datahandling
DatabaseHandler DBInfo;
XMLRequest xmlRequest;
TermSystem termSystem;  //this is initialized in DatabaseHandler
Navigator navBar;
SecondaryNavigator secondaryNavBar;
Boolean termSystemExists = false;  //keep track of weather or not it exists yet

//global variables 
String[]  date; //the lables of the dates for the visualization
String [] hours = {"temp"}; 
String [] is_news = {"temp"}; 
String [] has_news = {"temp"}; 
String [] order = {"temp"}; 
String [] name = {"temp"}; 
String [] score = {"temp"}; 
String [] all_terms = {"temp"}; 
String [] term_history = {"temp"}; 

String [] news_headline = {"temp"}; 
String [] news_keywords = {"temp"}; 
String [] news_category = {"temp"}; 
String [] news_score = {"temp"}; 

//variables for the selection process 
boolean somethingSelected = false;
int currentSelected = 0;
boolean inspecting = false; ///this is important.  It tells us which view we're looking at.
boolean showAll = true;  //keeps track of if we want to see all the back
boolean showNews = true;

//other variables
int interval; //this is huge!  It's the number of numbers processing can expect.

PFont font_small;
PFont font;
PFont font_medium;
PFont font_big;
PFont font_italic;
PFont font_bold;
PFont font_navigation;

PImage question;
PImage eye;
PImage akey;

//for the top navigation
String maxMeme= "none";
int maxMemeNumber = 0;
String maxFertelized= "none";
int maxFertelizedNumber = 0;
String maxCarnivorous= "none";
int maxCarnivorousNumber = 0;
//String [] maxSuggestions = {"temp"}; 
//int [] news_score = {"temp"}; 
String suggestion = "";//you want maybe 5 of these?



//some variables for different colors of news
int internationalColor;
int nationColor;
int scitechColor;
int sportsColor;
int entertainmentColor;
int businessColor;
int healthColor;


public void setup(){
  
   size(1000,700);
   background(150, 150, 150);
   smooth();

   interval = 0;
   font_small = loadFont("Corbel-10.vlw");
   font = loadFont("Corbel-14.vlw");
   font_navigation = loadFont("Corbel-Italic-12.vlw"); 
   font_medium = loadFont("ArialRoundedMTBold-30.vlw"); 
   font_italic = loadFont("BookmanOldStyle-Italic-16.vlw"); 
   font_big = loadFont("Corbel-Bold-50.vlw"); 
   font_bold = loadFont("Corbel-Bold-14.vlw"); 
   
   question = loadImage("question.png");
   eye = loadImage("eye.png");
   akey = loadImage("key.png");

   sportsColor= color(245, 0, 250);
   entertainmentColor= color(178, 0, 250);
   businessColor= color(240, 164, 0);
   healthColor= color(85, 70, 29);
   
   internationalColor = color(20, 240, 10);
   nationColor= color(10, 240, 199);
   scitechColor= color(252, 245, 0);
   
   DBInfo = new DatabaseHandler();   //make a new database handler to deal with the stuff coming in from the server
   navBar = new Navigator();  //Make a navigator to deal with the other elements of the page 
   
   //Before we get  data - initialize secondary Navigator and SecondaryTermSystem objects so they're ready for data
   secondaryNavBar = new SecondaryNavigator();
   
   //Let's do it!
  //xmlRequest = new XMLRequest(this, "http://www.upables.org/current/examples/backup4-4b.xml");
  //xmlRequest = new XMLRequest(this, "http://www.upables.org/current/examples/backup4-25.xml");
  //xmlRequest = new XMLRequest(this, "http://www.binaryspark.com/Academia/thesis_backup/backup4-25.xml");
  //xmlRequest = new XMLRequest(this, "http://www.upables.org/current/harvestor.php");
   xmlRequest = new XMLRequest(this, "http://www.upables.org/current/harvestor.php");
   xmlRequest.makeRequest();
   
}//end setup



public void draw() {
  noStroke();
  background(255);
  
  if (termSystemExists){ //if we're ready to do anything
      if (showAll) {navBar.renderBottom();}
      if (termSystem.terms.size() > 20) {termSystem.display(); }  
      if (inspecting) {secondaryNavBar.renderBottom();}  //if we're inspecting, display it on top
      if (showAll) {navBar.renderTop();}
  }//end if termsystem exists
}//end draw


public void netEvent(XMLRequest xmlRequest) {
    //println (" got to netEvent");
    
    //get the all the information as arrays
    String [] localHours = xmlRequest.getElementArray( "hours" );  //this will tell us how many intervals we will have
    String [] localIs_News = xmlRequest.getElementArray( "is_news" );
    String [] localHas_News = xmlRequest.getElementArray( "has_news" );
    String [] localDate = xmlRequest.getElementArray( "date" );
    String [] localOrder = xmlRequest.getElementArray( "order" );
    String [] localTerm = xmlRequest.getElementArray( "term" );
    String [] localScore = xmlRequest.getElementArray( "score" );
    String [] localAll_Terms = xmlRequest.getElementArray( "all_terms" );
    String [] localTerm_History = xmlRequest.getElementArray( "term_history" );
    String [] localNews_Headline = xmlRequest.getElementArray( "news_headline" );
    String [] localNews_Keywords = xmlRequest.getElementArray( "news_keywords" );
    String [] localNews_Category = xmlRequest.getElementArray( "news_category" );
    String [] localNews_Score = xmlRequest.getElementArray( "news_score" );   
    
    //now get it into the object you need
    DBInfo.recordDB(localHours, localIs_News, localHas_News, localDate, localOrder, localTerm, localScore, localAll_Terms, localTerm_History, localNews_Headline, localNews_Keywords, localNews_Category, localNews_Score);
  
 
  
}//end netevent


public void mousePressed() { 
  //someone's pressed somethin!  Only do something with it if we've got a termsystem!
  if(termSystemExists){
        if (inspecting) {secondaryNavBar.clickTracker();} //if we're inspecting
        
        else if (mouseY <= 30) {navBar.clickChecker();  }//if it was in the navigation bar
        
        else{                                             //otherwise, check other options
          if (somethingSelected) {termSystem.inspect();}
          else {termSystem.highlight();}
        }//end else
  }//end termsystemexists
}


public void keyReleased() {
  if (keyCode == 32) { showAll = !showAll; } //32
  if (key == 'n') {showNews = !showNews; }
      println ("Turning off visuals");
      
   if (key == 's') {save("Current_Screenshot.png"); }
   //if (key == 's') {save("Current_Screenshot.tif"); }
   
}//end keyreleased


class DatabaseHandler  {
   
//this is a class to handle all external interactions and route them to the correct place

DatabaseHandler () { 
 //Not a whole lot happening here
}//end constructor  
   
public void recordDB (String[] tempHours, String[] tempIs_News, String[] tempHas_News, String[] tempDate, String[] tempOrder, String[] tempTerm, String[] tempScore, String[] tempAll_Terms,  String[] tempTerm_History,  String[] tempNews_Headline,  String[] tempNews_Keywords,  String[] tempNews_Category,  String[] tempNews_Score) {
 
  //first, match up these to make them universal.  They're too big to pass every time.
  
//Let's start by just bringing in what we need for now.  No news information will be used.
  hours = tempHours;   //We'll use this for filling in the universal interval
  order = tempOrder;
  name = tempTerm; 
  score = tempScore;  
  all_terms = tempAll_Terms;
  
  is_news = tempIs_News; 
  has_news = tempHas_News;  
  term_history = tempTerm_History; 
  news_headline = tempNews_Headline; 
  news_keywords = tempNews_Keywords; 
  news_category = tempNews_Category; 
  news_score = tempNews_Score; 
  
  //Initialize the interval.  We'll need that for everything else.
  interval = PApplet.parseInt(hours[0]);
  println ("INTERVAL: " + interval);
  
  //use the date information to populate the Date aspect of the Navigator array
  
  navBar.initializeGrid(tempDate);
 
  termSystem = new TermSystem(); // I could pass the arrays here instead if I didn't want em to be global!
  termSystemExists = true;  //let the system know it's ready
    
  }   //end recordDB
}//end class


class Navigator  {
   //boolean mouseIsInTheHouse;
   String view;
   
   boolean mouseisinthehouseQuestion;
   boolean mouseisinthehouseEye;
   boolean mouseisinthehouseKey;


Navigator () { 
 
  //mouseIsInTheHouse = false;
  //view = "popularity";
   mouseisinthehouseQuestion = false;
   mouseisinthehouseEye= false;
   mouseisinthehouseKey = false;

}//end constructor  

//set up the names of the lables
public void initializeGrid (String[] localDate) {
  
   localDate = sort(localDate);
   date = new String[interval];  //move this to part of Database handler
  
   //now sort each individual guy into its own array cell
   String recentDate = "initial";
   int counter = 0;
   for (int i = 0; i < localDate.length; i++) {  //for every item in the date list
    
        if ((localDate[i].equals(recentDate)) == false) {  //this is the first time we've seen this term
          //println (counter + " has date " + localDate[i]);
          date[counter] = localDate[i];  //this is breaking when there are more or less than 24 items
          
          counter = constrain(counter+1, 0, interval-1); //make sure that counter never goes over interval - it will break the script
          recentDate = localDate[i];
        }//end if
   }//end for
}//end initializeGrid


public void renderBottom(){
  
  //first lets have some dates and lines
      for (int i = 0; i < date.length; i++) {   //change this to length!
        fill(0, 50);
        stroke(05, 50);
        strokeWeight(1);
        line(map(i, 0, interval-1, 0, width), 0, map(i, 0, interval-1, 0, width), height);
        
        //now render some lables for each hour!
        rectMode(CORNER);
        textFont(font); 
        text(date[i], map(i, 0, interval-1, 0, width)+5, 35, 50, 200);  
      }//end for
      
}  //end render bottom


public void renderTop(){
  //let's do it!
  //first we want a very thin nav bar at top
  fill(150);
  noStroke();
  rect (0,0, width, 30);
  fill(200);
  textFont(font_medium);
  text("current", 5,25);
  
  image(question, width-140, 0);
  image(eye, width-90, 0);
  image(akey, width-40, 0);
  
  fill(150, 240);
  strokeWeight(1);
  stroke(255);
  textFont(font_bold); 
  
  //now let's reset all the mouseIntheHouse to make sure they're still relevant
  if(mouseY >= 30) {mouseisinthehouseQuestion = false; mouseisinthehouseEye = false; mouseisinthehouseKey = false;}
  if((mouseisinthehouseQuestion) && ((mouseX <= width-140) || (mouseX > width-100))) {mouseisinthehouseQuestion = false;}
  if((mouseisinthehouseEye) && ((mouseX <=width-100) || (mouseX > width-50))) {mouseisinthehouseEye = false;}
  if((mouseisinthehouseKey) && ((mouseX <= width-50) || (mouseX > width))) {mouseisinthehouseKey = false;}
  
  //now let's render the fiddly bits
  if (mouseisinthehouseQuestion) {
    rect(width-430, 30, 330, 290); 
    fill(255);
    text("What's All This Then?", width-420, 50);
    textFont(font);
    text("Current is a real time data visualization of internet memes as they carry out lifecycle activities of birth, evolution, and decline in reaction to the daily news cycle.  Visualizing the capricious nature of public attention lets us spotlight missed opportunities in news coverage. \n\nThis project has been created by Zoe Fraade-Blanar. She likes messing around with news, visualizations, news visualizations, and visualizations about news.  Like it?  Why don't you tell her! ", width-420, 75, 310, 500);
    textFont(font_navigation);
    text("http://www.binaryspark.com\nfraade@gmail.com", width-420, 275);
  }
  
  else if (mouseisinthehouseEye) {
    rect(width-380, 30, 330, 375); 
    fill(255);
    text("Time Interval at a Glance!", width-370, 50);
    textFont(font);
    text("Most successful meme \n \nMost fertalized meme \n \nMost carnivorous meme \n \nBest bets for journalism coverage", width-370, 75, 310, 500);
    
    textFont(font_navigation);
    text (maxMeme, width-360, 90, 310, 100);
    text (maxFertelized, width-360, 125, 310, 100);
    text (maxCarnivorous, width-360, 155, 310, 100);
    text (suggestion, width-360, 180, 310, 220);
   textFont(font);  
  }//end if
  
  else if (mouseisinthehouseKey) {
    rect(width-331, 30, 330, 400); 
    fill(255);
    text("What's it all mean?", width-320, 50);
    textFont(font);
    strokeCap(SQUARE);
      //coverage
      for (int w = 0; w<40; w++) {
        strokeWeight(6);
        stroke (map(w,0, 40,10, 255), map(w,0, 40,0, 255), map(w,0, 40,100, 255));
        line(map(w, 0, 40, width-300, width-20), 70, map(w, 0, 40, width-300, width-20), 90);
       }
      textFont(font_navigation);
      text("High coverage", width-305, 105);
      text("Low coverage", width-95, 105);
       
      //interest
      strokeWeight(1);
      stroke(255);
      fill(150, 150, 200);
      beginShape();
      vertex(width-305, 130);
      vertex(width-25, 140);
      vertex(width-305, 150);
      endShape(CLOSE);
      fill(255);
      text("High interest", width-305, 165);
      text("Low interest", width-90, 165);
      
      //news
      noStroke();
      fill(sportsColor);
      ellipse(width-290, 210, 20,20);
      fill(255);
      text("Sports News", width-270, 210);
      
      fill(entertainmentColor);
      ellipse(width-290, 240, 20,20);
      fill(255);
      text("Entertainment News", width-270, 240);
      
      fill(businessColor);
      ellipse(width-290, 270, 20,20);
      fill(255);
      text("Business News", width-270, 270);
      
      fill(healthColor);
      ellipse(width-290, 300, 20,20);
      fill(255);
      text("Health News", width-270, 300);
      
      fill(internationalColor);
      ellipse(width-130, 225, 20,20);
      fill(255);
      text("International News", width-110, 225);
      
      fill(nationColor);
      ellipse(width-130, 255, 20,20);
      fill(255);
      text("National News", width-110, 255);
      
      fill(scitechColor);
      ellipse(width-130, 285, 20,20);
      fill(255);
      text("SciTech News", width-110, 285);
 
    //then do press spacebar to toggle visuals
    textFont(font);
    fill(255);
    stroke(0);
    rect(width-300, 335, 120, 25);
    fill(0);
    text("[SPACEBAR]", width-276, 353);
    textFont(font_navigation);
    fill(255);
    text("Toggle data guides", width-170, 350);
    
    
    fill(255);
    stroke(0);
    rect(width-300, 375, 30, 25);
    textFont(font);
    fill(0);
    text("[n]", width-290, 393);
    textFont(font_navigation);
    fill(255);
    text("Toggle news", width-260, 390);
    
  }  
  
}//end rendertop


   
public void  clickChecker() {
    if ((mouseX >width-140) && (mouseX <=width-100)) { mouseisinthehouseQuestion = true; mouseisinthehouseEye = false; mouseisinthehouseKey = false; }
    if ((mouseX >width-100) && (mouseX <=width-50)) { mouseisinthehouseQuestion = false; mouseisinthehouseEye = true; mouseisinthehouseKey = false;}
    if ((mouseX >width-50) && (mouseX <=width)) { mouseisinthehouseQuestion = false; mouseisinthehouseEye = false; mouseisinthehouseKey = true;}
  
   //in draw, remember every time through to check the position of the mouse.  If it's not within the spot it was, turn all of them to false!

 //println("question");
 //println("eye");
 //println("key");
 } //end clickchecker 
   
     
}//end class
class NewsItem {
  
  String Headline;
  String Keywords; 
  String Category; 
  int Score;
  boolean newsExists; //keeps track of if anything is in this one
  
  
  //constructor
  NewsItem(String tempHeadline, String tempKeywords, String tempCategory, int tempScore) {
    
     Headline = tempHeadline;
     Keywords = tempKeywords; 
     Category = tempCategory; 
     Score = tempScore;
     newsExists = false;
    
  }//end constructor
  
  
///Calculate out the current size, based on the score  
public int getSize(){
  int presentSize = constrain((Score/20), 2, 80);
  return presentSize;
}//end getsize



public void render(int xlocal, int ylocal) {
  
  //stroke(255);
  fill(255, 50);
  smooth();
  
  //this should be for show details!
 
  if (Category.equals("international")) {stroke(internationalColor); }
  else if (Category.equals("nation")) {stroke(nationColor);}
  else if (Category.equals("scitech")) {stroke(scitechColor);}
  else if (Category.equals( "sports")) {stroke(sportsColor);}
  else if (Category.equals("entertainment")) {stroke(entertainmentColor); }
  else if (Category.equals("business")) {stroke(businessColor);}
  else if (Category.equals("health")) {stroke(healthColor);}
  else {stroke(255);}
  

  int itemSize = PApplet.parseInt(getSize()/2.8f);
  ellipse(xlocal, ylocal, itemSize, itemSize);
}//end render



public void renderExtra(int xlocal, int ylocal) {
  //RENDER THE STUFF ON TOP  
  //println(Category);
 
  if (Category.equals("international")) {fill(internationalColor, 40); }
  else if (Category.equals("nation")) {fill(nationColor, 40);}
  else if (Category.equals("scitech")) {fill(scitechColor, 40);}
  else if (Category.equals( "sports")) {fill(sportsColor, 40);}
  else if (Category.equals("entertainment")) {fill(entertainmentColor,40); }
  else if (Category.equals("business")) {fill(businessColor,40);}
  else if (Category.equals("health")) {fill(healthColor,40);}
  else {fill(0, 255, 255);}
   
  noStroke();
  strokeWeight(1);//for testing
  stroke(255);//for testing
  smooth();
  //fill(255, 30);
  
  int itemSize = PApplet.parseInt(constrain((map(Score, 350, 5000, 2, 5000)/30), 2, 85)); //let's get a more realistic aspect of the size
  ellipse(xlocal, ylocal, itemSize, itemSize);
}//end render
  

    
  }
class SecondaryNavigator  {
   //boolean mouseIsInTheHouse;
   String[] inspectorDate = {"temp"}; 
   int[] inspectorOverallTermLast; 
   int[] inspectorOverallTerm; 
   String[] termHistory;  //we'll use this to populate the submemes
   ArrayList subMemeList;    // An arraylist for all the particles
   
   //standard
   int localInterval;
   boolean isNews;
   int myColor;
   String secondaryName;
   
   //for the terms on the left
   int termTotal;
   float percentageCovered;
   boolean news_Lacking;
   String contributingTerms;
   
SecondaryNavigator () { 
     println("secondaryNav created");
     localInterval = 0;
     subMemeList = new ArrayList();
     contributingTerms = "";
     
}//end constructor  

public void fillSubMemes()  {
  //println(myColor);//for testing only

 //arrays to hold the parts of the history
  String[] something;
  String[] individual;
   
  //now we're going to go through termHistory.  For each date, we're going to check...
  for (int j = 0; j < termHistory.length; j++) {  //for every date in the termHistory for this meme
      //print("TERM: " + termHistory[j] + " IS MADE OF ");  //overall terms
      
      if (termHistory[j] != null) { //if there's no term history in this date (if it's 0) don't bother
          something = split(termHistory[j], "-");
          
          for (int k = 0; k < something.length; k++) {  //for each item in the history of this date
            //print(something[k] + " AND ");
            String myTerm = trim(something[k]);  //history (only for places where there is something...some places it will be null.
            individual = split(myTerm, "=");
            //print(trim(individual[0])+" AND ");
            //println(trim(individual[1]));
            
            //Now we're ready
            String title = trim(individual[0]);
            int score = PApplet.parseInt(trim(individual[1]));
            boolean isMatched = false;
            int matchingTerm = 0;
            
            for (int m = 0; m < subMemeList.size(); m++) { 
                SecondaryTerm s = (SecondaryTerm) subMemeList.get(m);
                //println ("DOES " + s.termName + " EQUAL " + title);
                
                if (s.termName.equals(title)) {isMatched = true; matchingTerm = m; }
                else {
                //println("DOES NOT EQUAL"); 
              }
            }//end for
            //there's no match!  create a new one!
            if (isMatched == false) { 
              //println (title); 
              //subMemeList.add(new SecondaryTerm(title, score, isNews, "none", j)); 
              subMemeList.add(new SecondaryTerm(title, score, isNews, "none", j, localInterval, myColor)); //where j is the order
              contributingTerms =  contributingTerms + "\n" + title;
              //println("Adding new");
            }
            //there was a match!  Add to it!
            else {
              //println ("adding to existing");
              SecondaryTerm s = (SecondaryTerm) subMemeList.get(matchingTerm);
              //I don't need to add a new one, I just need to get the previous number from the last one of this date
              s.insertScore(score, j); //where j is the order
            }//end else
          } //end first for
      }//end if
  }//end second for
    
    //now let's turn those into real numbers!
    cleanup();
}//end fill submemes


//specifically to fill in news!  yay!
public void addNews(String tempHeadline, String tempCategory, int tempScore, int tempOrder){
  //println("so make some news at " + tempOrder);
  //println(tempHeadline +" AND "+ tempScore+" AND "+ "true"+" AND "+ "none"+" AND "+ tempOrder+" AND "+ localInterval+" AND "+ myColor);                          
  subMemeList.add(new SecondaryTerm(tempHeadline, tempScore, true, tempCategory, tempOrder, localInterval, myColor)); //where j is the order
  //println(tempScore);
  //we must replace none with the cateogory
}


public void cleanup(){
    //once we're done with all,
    //initialize the very bottom line
    int[] previousTermScores = new int[localInterval];  //this is to hold the previous scores and add it to the current one
    for (int i = 0; i < previousTermScores.length; i++) { previousTermScores[i] = inspectorOverallTermLast[i];}// this should be equal to overallInspectorTermLast
    boolean firstNonNews = true;
    int firstNonNewsNumber = 0;
    
    for (int m = 0; m < subMemeList.size(); m++) { 
                SecondaryTerm s = (SecondaryTerm) subMemeList.get(m);
                s.lastTermScores = previousTermScores;
                int largest = 0;
                
                for (int n = 0; n < localInterval; n++){ 
                  if (s.absoluteTermScores[n] > largest) {largest = s.absoluteTermScores[n]; s.maxDiff = n;}//so we know the fattest point
                  
                  s.termScores[n] = s.lastTermScores[n] + s.absoluteTermScores[n];
                  if ((!s.isNews) && (firstNonNews)) {firstNonNews = false; firstNonNewsNumber = m;} //if it's not news and this is the firstt ime we're seen that, 
                  //print (s.termScores[n] + " ");
              }//end second for
              //println();
              //now reset PTS so the next one can be used.  
              previousTermScores = s.termScores;
              inspectorOverallTerm = s.termScores; //when its done we'll be left with the last line on the graph since this wasn't reallly graphic

      //while we're here, find fattest point, use the numbers to update the previous ones with actual numbers so you can render lables.

      
      
    }//end for going through whole list
    
  //Now, we must set inspectorOverallTermLast equal to just the non-news items
  //println(firstNonNewsNumber);
  SecondaryTerm st = (SecondaryTerm) subMemeList.get(firstNonNewsNumber);
  inspectorOverallTermLast = st.lastTermScores;
  
}//end cleanup



public void renderBottom(){
  
  fill(255, 150);
  rect(0,0,width, height);
  
  //println("render bottom");
  //stroke(255, 81, 0);
  stroke(100);
  strokeWeight(3);
  rectMode(CORNERS);
  fill(255, 220);
  rect(25, 100, 975, height-25);
  
  fill(100);
  noStroke();
  rect(800, 100, 975, height-25);
  
  rectMode(CORNER);
  fill(100);
  noStroke();
  rect (937, 60, 40, 40);
  stroke(255);
  line (946, 67, 968, 90);
  line (968, 67, 946, 90);
  
  //first lets have some dates and lines
      for (int i = 0; i < localInterval; i++) {   
        fill(0, 50);
        stroke(0, 50);
        strokeWeight(1);
        line(map(i, 0, localInterval-1, 70, 760), 200, map(i, 0, localInterval-1, 60, 760), height-50);
        
        if ((i == 0) || (i == localInterval-1)) {//now render some lables for each hour!  Just do the first or last
          rectMode(CORNER);
          textFont(font); 
          text(inspectorDate[i], map(i, 0, localInterval-1, 70, 760)-15, 170, 50, 200); 
        }//end if 
      }//end for
 
 //let's call a separate function to render all the important text on the right here - break this out once you have the numbers from the front
 
 //now let's render the meme name!  big!
    textFont(font_medium);
    fill(100); 
    text(secondaryName, 40, 140);
 //and the title
    textFont(font_italic);
    fill(100); 
    text("Anatomical Details", 40, 160);
    
  //and the title and details on the right
  //let's call this as a separate function
    memeDetails();
 
   //then, let's render the meme outline (eventually plus news outline)
   //stroke(150);
   strokeWeight(20);
   strokeJoin(ROUND);
   strokeCap(ROUND);


   //fill - fill it with the color of what it is on the other map.  Get this! It will look like:
   fill (map(myColor,0, 255,10, 255), map(myColor,0, 255,0, 255), map(myColor,0, 255,100, 255));
   stroke (map(myColor,0, 255,10, 255), map(myColor,0, 255,0, 255), map(myColor,0, 255,100, 255));
   
   beginShape();
   
           //now plot the upper line!
          curveVertex(760, inspectorOverallTermLast[localInterval-1]);  //repeat the point on the right
          for (int i = localInterval-1; i>=0; i--) {
            curveVertex(map (i, 0, localInterval-1, 70, 760),  inspectorOverallTermLast[i]); //repeat the last one
          }//end for
          curveVertex(70, inspectorOverallTermLast[0]);  //repeat the last one
          
           //plot the lower line!
          curveVertex(70,  inspectorOverallTerm[0]);
          for (int i = 0; i < localInterval; i++) {
            curveVertex(map (i, 0, localInterval-1, 70, 760),  inspectorOverallTerm[i]); //repeat the last one
          }
          curveVertex(750, inspectorOverallTerm[localInterval-1]);  //repeat the point on the right
         
      endShape();
      //now, render an extra line between the right-most items.  Why?  Because for some reason there's a bug.
      line(760, inspectorOverallTermLast[localInterval-1], 760, inspectorOverallTerm[localInterval-1]);
      
      //Render some Undernews!//
      
     //strokeWeight(0);
     noStroke();
     strokeJoin(ROUND);
     strokeCap(ROUND);
      
      //now we need to go through and render just the news as circles to get that background!
       for (int i = 0; i <= subMemeList.size()-1; i++) { 
          SecondaryTerm t = (SecondaryTerm) subMemeList.get(i);
          if(t.isNews){
           
            //int mySize = int(constrain(t.newsScore, 10, 500)/8);
            int mySize = constrain(PApplet.parseInt(t.absoluteTermScores[t.newsOrder]/1.05f), 40, 1000);  //mess with 1.05
            int ypos = t.absoluteTermScores[t.newsOrder]/2+t.lastTermScores[t.newsOrder]-5; //mess with the 15
            ellipse(map(t.newsOrder, 0, localInterval-1, 70, 760), ypos, mySize, mySize);
          }//end if  
      }//end for
    
    //now call render top to get the anatomical details
    renderTop();

    
  }  //end render bottom
     
 
 public void renderTop() {
   
   //first render the whooshes
   for (int i = 0; i <= subMemeList.size()-1; i++) { 
      //for (int i = 0; i <=4 ; i++) {  //for testing only
        SecondaryTerm t = (SecondaryTerm) subMemeList.get(i);
        if (!t.isNews) {t.render();}
    }//end for
    
    //then render the news!
      for (int i = 0; i <= subMemeList.size()-1; i++) { 
      //for (int i = 0; i <=4 ; i++) {  //for testing only
        SecondaryTerm t = (SecondaryTerm) subMemeList.get(i);
        if (t.isNews) {t.render();}
    }//end for
    
    //finally, render the meme lables!!!
    
    for (int i = 0; i <= subMemeList.size()-1; i++) { 
      //for (int i = 0; i <=4 ; i++) {  //for testing only
        SecondaryTerm t = (SecondaryTerm) subMemeList.get(i);
        if (!t.isNews) {t.memeLabelRender();}
    }//end for 
 }//end rendertop
     
     
 
 //Meme details
public void memeDetails () {
    textFont(font_italic);
    fill(255, 100); 
    stroke(255, 100);
    strokeWeight(1);
    text("Taxonomy", 880, 160); 
    line(810, 165, 960, 165);
    
    //this whole section should be part of TermSystem, a function it calls just once.  tempInterest = interest, tempCoverage=coverage
    String tempInterest;
    int tempInterestScore;
    if (termTotal >700) { tempInterest = "High Interest"; tempInterestScore = 3;}
    else if (termTotal > 200) { tempInterest = "Medium Interest"; tempInterestScore = 2;}
    else { tempInterest = "Low Interest"; tempInterestScore = 1;}
    
    String tempCoverage;
    int tempCoverageScore;
    if (percentageCovered < 1) { tempCoverage = "Very Low Coverage"; tempCoverageScore = 1;}
    else if ((percentageCovered < 3)|| (news_Lacking)) { tempCoverage = "Low Coverage"; percentageCovered = 0; tempCoverageScore = 1;}
    else if (percentageCovered < 7) { tempCoverage = "Medium Coverage"; tempCoverageScore = 2;}
    else  {tempCoverage = "High Coverage"; tempCoverageScore = 3;} 
    
    String reccomendation = "";
    
    if (tempInterestScore > tempCoverageScore) {reccomendation = "Cover this meme. There is significant untapped interest here waiting for media coverage.";} //always cover when there's a gap
    else if (tempCoverageScore == 3) {reccomendation = "Don't bother covering this meme. It is already saturated with media coverage for this level of interest.";} //if it already has high coverage, don't cover
    
    else if ((tempCoverageScore == 2) && (tempInterestScore == 2)) {reccomendation = "Consider covering this meme. There may still be room for more media coverage despite the current levels.";}
    else if ((tempCoverageScore == 2) && (tempInterestScore == 1)) {reccomendation ="Don't bother covering this meme. It is already saturated with media coverage for this level of interest.";}
    
    else if ((tempCoverageScore == 1) && (tempInterestScore == 1)) {reccomendation ="Consider covering this meme. There may still be room for more media coverage despite the relatively low level of interest.";}
    else {reccomendation ="Missed something";}

   //now, render some titles
    textFont(font_bold);
    fill(255); 
    text("Interest", 810, 195);
    text("Media Coverage", 810, 235);
    text("Reccomendation", 810, 280);
    text("Related Topics", 810, 390);
    
    textFont(font);
    text(termTotal + " (" + tempInterest + ") ", 810, 210);
    text(PApplet.parseInt(percentageCovered) + "% (" + tempCoverage + ") ", 810, 250);
    text(reccomendation, 810, 285, 150, 1000);
    text(contributingTerms, 810, 380, 150, 1000);
}
     
     
     
 public void initializeInspector() {
   
  //first, we're going to empty subMemeList
  for (int i = subMemeList.size()-1; i >= 0; i--) { subMemeList.remove(i);}
   
 //Now fill perlin values into inspectorOverallTermLast
  float xoff = 0.1f;
  float a = 0.3f;
  float inc = TWO_PI/15.0f;
  //a temporary array to hold this information
  int[] tempSine = new int[inspectorDate.length];

    for(int i=0; i < inspectorDate.length; i=i+1) {
        xoff = xoff + 50;
        a = a + inc;
        int temp = PApplet.parseInt((noise(xoff))*130);
        tempSine[i] = temp+270; //mess with 270 to control where it starts
    }//end for
  inspectorOverallTermLast = tempSine;

}//calculate Sine    
     
     
 public void clickTracker() {
   if ((mouseX > 937) && (mouseX < 937+40) && (mouseY > 60) && (mouseY < 100)) {
     println ("I don't want a meme anymore!");
     inspecting = false;
   }//end if
 }   //end clicktracker
     
 
     
     
}//end class
class SecondaryTerm {
  
  int[] absoluteTermScores; //the set scores as reported form the internet
  int[] termScores; //the set scores as reported form the internet
  int[] lastTermScores; //the last term's plotted points
  
  String termName;
  String shortName;
  boolean isNews; //this will store if this is a real term or only here for a news reason
  int localInterval;
  int myColor;
  int newsScore; //the actual, unchanged score for each news item
  int newsOrder;
  int termTotal;
  String newsCategory;
  int maxDiff;
;
  
  //these are to tell us where to start our pointer
  //int xPointer, yPointer;
  //int xBox, yBox;
  //int xBox1, yBox1;
  //int xText, yText;
  //int xLink;
  

  //CONSTRUCTOR
  SecondaryTerm(String tempName, int tempScore, boolean tempIs_news, String category, int tempOrder, int tempInterval, int tempColor) {
    
    ///////////Set up the universal constants!///////////
    termName= tempName;   
    isNews = tempIs_news;
 
      if ((!isNews) || (tempName.length() <= 22)) {shortName = tempName;}
      else {shortName = tempName.substring(0, 21); shortName = shortName+"...";}
      
    localInterval = tempInterval;
    myColor = tempColor;
    newsOrder = 0;
    if (isNews){newsOrder = tempOrder;}
    //newsCategory = "none";
    newsCategory = category;
    
    //create everything
    termScores= new int[localInterval];
    lastTermScores = new int[localInterval];  //I'll use this to plot the bottom of the curve, and calculate color
    absoluteTermScores = new int[localInterval];
   
    //initialize the additive item
    for (int i = 0; i < termScores.length; i++) {
      termScores[i] =  0;
      lastTermScores[i] = 0;
      absoluteTermScores[i] = 0;
    }//end for
        
        
    //now call a function to insert the first score (tempScore) in the proper (termOrder) slot of (termScore)
    insertScore(tempScore, tempOrder);

  }//end constructor
  
  
  
public void insertScore(int theScore, int theOrder) {
    newsScore = theScore; //this stores the real score before we make it all big and small and stuff
    
    if (!isNews){absoluteTermScores[theOrder] = PApplet.parseInt(theScore*2.2f);}  //maybe shouldn't do the 2.o here.  Constrained for now
    
    else {absoluteTermScores[theOrder] = constrain(theScore, 10, 750)/8; }
    //we'll fill in the other two arrays once everything is filled in
    
}//end insertScore  


public void render() {

     if (!isNews) { //if it's not news
          
          if (myColor >230) { stroke(0);} //if it's white
          else {stroke (map(myColor,0, 255,10, 255), map(myColor,0, 255,0, 255), map(myColor,0, 255,100, 255));}
          
         
          strokeWeight(3);
          fill (255);
     
          beginShape();
               //plot the bottom!
              curveVertex(70,  termScores[0]);
              for (int i = 0; i < termScores.length; i++) {
                curveVertex(map (i, 0, termScores.length-1, 70, 760),  termScores[i]); //repeat the last one
              }
              curveVertex(760, termScores[localInterval-1]);  //repeat the point on the right
             
             //now plot the top!
              curveVertex(760, lastTermScores[localInterval-1]);  //repeat the point on the right
              for (int i = lastTermScores.length-1; i>=0; i--) {
                curveVertex(map (i, 0, lastTermScores.length-1, 70, 760),  lastTermScores[i]); //repeat the last one
              }//end for
              curveVertex(70, lastTermScores[0]);  //repeat the point on the left
         
          endShape();
          
           //add an extra line to the beginning
           line(70, lastTermScores[0], 70,  termScores[0]);
                   
 }//end if isNews == false
 
 else{
  //render it as some news!!!!! you'll want to use the category color here
            //noStroke();
            strokeWeight(2);
            stroke (map(myColor,0, 255,10, 255), map(myColor,0, 255,0, 255), map(myColor,0, 255,100, 255));
            //fill(255);
            
            if (newsCategory.equals("international")) {fill(internationalColor); }
            else if (newsCategory.equals("nation")) {fill(nationColor);}
            else if (newsCategory.equals("scitech")) {fill(scitechColor);}
            else if (newsCategory.equals( "sports")) {fill(sportsColor);}
            else if (newsCategory.equals("entertainment")) {fill(entertainmentColor); }
            else if (newsCategory.equals("business")) {fill(businessColor);}
            else if (newsCategory.equals("health")) {fill(healthColor);}
            else {fill(0, 255, 255);}
            
            int mySize = constrain(PApplet.parseInt(absoluteTermScores[newsOrder]/2), 4, 1000);
            int ypos = absoluteTermScores[newsOrder]/2+lastTermScores[newsOrder]-5; //mess with the 5
            int xpos = PApplet.parseInt(map(newsOrder, 0, localInterval-1, 70, 760));
            ellipse(xpos, ypos, mySize, mySize);
            
            //now, if the actual score is over 3000, render a small plus in the center
            if (newsScore > 3500) {
              strokeWeight(1);
              stroke(0, 100);
              line(xpos-2, ypos, xpos+2, ypos);
              line(xpos, ypos-2, xpos, ypos+2);
              //println("got in");
            }
            
            //now we have to render the lables!!!!!
            
            strokeWeight(1);
            stroke(50);
            line(xpos, ypos-mySize/2, xpos-10, ypos-mySize/2-40);
            
            rectMode(CORNER);
            textFont(font_small);
            fill(50); 
            pushMatrix();
              translate(xpos-10, ypos-mySize/2-40);
              rotate(PI/-3.2f);
              text(shortName, 0,0);
            popMatrix();
 }//end else
}//end render



public void memeLabelRender(){
  
            //everything here needs be be a separate function
            int xpos = PApplet.parseInt(map(maxDiff, 0, localInterval-1, 70, 760));
            int ypos = lastTermScores[maxDiff]+PApplet.parseInt((absoluteTermScores[maxDiff]/2));
            
            strokeWeight(1);
            stroke(50);
            fill (50);
            line(xpos, ypos, xpos-20, lastTermScores[maxDiff]+80);
            ellipse(xpos, ypos, 4, 4);
            
            
            rectMode(CORNER);
            textFont(font_small);
            fill(50); 
            pushMatrix();
              translate(xpos-20, lastTermScores[maxDiff]+85);
              rotate(PI/5.2f);
              text(shortName, 0,0);
            popMatrix();
 
}//end meme lable render


//for testing only  
public void printContents() {
    //for testing, print out previousTermScores
     print (termName + ": ");
     for (int x = 0; x < termScores.length; x++) { print(termScores[x] + "-");}
     println("");
}//end Printcontents  

}

class Term {
  
  int[] termScores; //the set scores as reported form the internet
  int[] lastTermScores; //the last term's plotted points
  String [] termHistory; //the last term's history for each item
  //int[] absoluteTermScores; //the actual datapoints to plot.  Might be helpfull

  //the Array of new items associated
  NewsItem[] newsArray;
  
  int selected; //this will be a timer to see if this item has been selected
  String termName;
  
  String all_terms;
  boolean isNews; //this will store if this is a real term or only here for a news reason
  String isNews_headline; //just for isNews items
  
  int myColor;//these are used to calculate the news/request overlap
  int termTotal;
  int newsTotal; 
  
  boolean news_Lacking;
  
  //these are to tell us where to start our pointer
  int xPointer, yPointer;
  int xBox, yBox;
  int xBox1, yBox1;
  int xText, yText;
  int xLink;
  int boxHeight;
  int boxWidth;
  float percentageCovered;


  //CONSTRUCTOR
  Term(int tempOrder, String tempName, int tempScore, int[] tempPreviousTermScores, String tempAll_Terms, String tempIs_news, String tempHas_news, String tempNewsHeadline, int tempNewsScore, String tempNewsCategory, String tempTermHistory) {
    
    ///////////Set up the universal constants!///////////
    termName= tempName;
    myColor = 255;
    isNews = PApplet.parseBoolean(tempIs_news);
    //println("IsNews: " + isNews);
    selected = 0;  //if there needs to be word baloon
    newsTotal = 1;
    termTotal = 1;
    percentageCovered = 0;
    news_Lacking = false;
    termHistory = new String[interval];
    
    isNews_headline = " ";
   
    ///////////Deal with the news//////////////
     //create and initialize the newsArray
      newsArray = new NewsItem[interval];
      for (int i = 0; i < newsArray.length; i++) {
        newsArray[i] = new NewsItem("none", "none", "none", 0);
      }//end for
      
      //Now insert the first one!
      //println("NEW ITEM");
      insertNews(PApplet.parseBoolean(tempHas_news), tempOrder, tempNewsHeadline, PApplet.parseInt(tempNewsScore), tempNewsCategory);


    /////////////new get that term info in there!////////////
    //create everything
    termScores= new int[interval];
    lastTermScores = new int[interval];  //I'll use this to plot the bottom of the curve, and calculate color
    //println(tempHas_news);
   
    //initialize the additive item
    for (int i = 0; i < termScores.length; i++) {
      termScores[i] =  tempPreviousTermScores[i];
      lastTermScores[i] = tempPreviousTermScores[i];
    }//end for
        
    //get the string of all the terms
    all_terms = tempAll_Terms.replace('-', '\n');
    //boxHeight = all_terms.length();
    if (!isNews) {boxWidth = termName.length();}
    else {boxWidth = isNews_headline.length();}
    //println (boxWidth);

    //now call a function to insert the first score (tempScore) in the proper (termOrder) slot of (termScore)
    if (isNews == false) {insertScore(tempScore, tempOrder, tempTermHistory);}
    else { insertScore(newsArray[tempOrder].getSize(), tempOrder, tempTermHistory); }
     
    //before we go, count the dashes in the history 
     int count = tempAll_Terms.split("-").length-1;
     if (maxCarnivorousNumber < count) {maxCarnivorousNumber = count; maxCarnivorous = termName;} 

  }//end constructor
  
  
  
public void insertScore(int theScore, int theOrder, String theTermHistory) {
    //termScores[theOrder] = termScores[theOrder]+int(theScore*2.0);  //play with that 2.5!!!
    if (isNews ==false) {termScores[theOrder] = termScores[theOrder]+PApplet.parseInt(theScore*1.8f) + newsArray[theOrder].getSize();}  //play with that 2.5!!!
    else {termScores[theOrder] = termScores[theOrder]+newsArray[theOrder].getSize()/7; }  //play with 5
    termHistory[theOrder] = theTermHistory;
}//end insertScore  


public void insertNews(boolean hasNews, int theOrder, String tempHeadline, int tempScore, String tempCategory) {
    //calculate what the real score will be, based on the last score for that slot and put it in there
    
    //println ("HAS NEWS? " + hasNews);
    if (hasNews == true) { 
        newsArray[theOrder].newsExists = true;
        newsArray[theOrder].Headline = tempHeadline;
        newsArray[theOrder].Score = tempScore;
        newsArray[theOrder].Category = tempCategory;
        
        if (isNews) {isNews_headline = tempHeadline;} //so we can access it easily later
    }//end if
}//end insertNews
  
  
public void render() {
  
  //////////////////////////////////////////////
  //////first, let's render just the whooshes///
  /////////////////////////////////////////////
  if (isNews == false) {  //if there's more here than just news
     //println("about to render something");
      //stroke(255);
      stroke(220);
      strokeWeight(1);
      
      fill (map(myColor,0, 255,10, 255), map(myColor,0, 255,0, 255), map(myColor,0, 255,100, 255));

      //except when it's selected
      if (selected >1) {fill(0);}
      
      beginShape();
      
           //plot the bottom!
          curveVertex(0,  termScores[0]);
          for (int i = 0; i < termScores.length; i++) {
            curveVertex(map (i, 0, termScores.length-1, 0, width),  termScores[i]); //repeat the last one
          }
          curveVertex(width, termScores[interval-1]);  //repeat the point on the right
         
         //now plot the top!
          curveVertex(width, lastTermScores[interval-1]);  //repeat the point on the right
          for (int i = lastTermScores.length-1; i>=0; i--) {
            curveVertex(map (i, 0, lastTermScores.length-1, 0, width),  lastTermScores[i]); //repeat the last one
          }//end for
          curveVertex(0, lastTermScores[0]);  //repeat the point on the right
     
      endShape();
      
  //////////////////////////////////////////////
  //////Now, render some news!!!!!!!!!!!!!!!///
  /////////////////////////////////////////////
  
  if(showNews){
    fill (0, myColor);
    stroke(255);
  
      for (int i = 0; i < newsArray.length; i++) {
          if (newsArray[i].newsExists==true) {
             newsArray[i].render(PApplet.parseInt(map(i, 0, interval-1, 0, width)), (termScores[i] - lastTermScores[i])/2 + lastTermScores[i]);
          }//end if
        }//end for 
    }//end if
  }//end if
}//end render


//A special render just for items that are only news
public void isNewsRender() {
  
  //If isNews=true, let's render it separately!  We may want to separate this out and move this to the term system so it always happens first.
  for (int i = 0; i < newsArray.length; i++) {
      if (newsArray[i].newsExists==true) {
         newsArray[i].renderExtra(PApplet.parseInt(map(i, 0, interval-1, 0, width)), (termScores[i] - lastTermScores[i])/2 + lastTermScores[i]);
      }//end if
  }//end for 
}//isNewsRender



public void topRender(){
  // check if you need to render a wordBaloon
  if (selected != 0) {
    //calculate the thickest part of the bubble
    fill(100);
    stroke(100);
    
    //make the line
    ellipse(xPointer, yPointer, 5, 5);
    strokeWeight(2);
    line(xPointer, yPointer, xBox, yBox);
    
    //make a rectangle somewhere on the screen where it will be visible
    strokeWeight(1);
    rectMode(CORNERS);
    fill(255, 220);
    rect(xBox, yBox, xBox1, yBox1);
    
    //first, get the text ready for the box.  SHould this all be moved to part of cleanup?  Probably.
    String tempInterest;
    String tempCoverage;
    
    if (termTotal >700) { tempInterest = "High Interest";}
    else if (termTotal > 200) { tempInterest = "Medium Interest";}
    else { tempInterest = "Low Interest";}
    
    if (percentageCovered < 1) { tempCoverage = "Very Low Media Coverage";}
    else if ((percentageCovered < 3)|| (news_Lacking)) { tempCoverage = "Low Media Coverage";}
    else if (percentageCovered < 7) { tempCoverage = "Medium Media Coverage";}
    else  {tempCoverage = "High Media Coverage";}
       
    if (!isNews) {
      //now make a secondary rectangle to click on!
      fill(150);
      noStroke();
      rect(xText+5, yText+60, xLink, yText+85);
      
      rectMode(CORNER);
      textFont(font); 
      fill(0);
      text("Term:", xText+20, yText+10);  
      text("Interest:", xText+9, yText+30); 
      text("Coverage:", xText+5, yText+50); 

      fill(100);
      text(termName, xText+70, yText, 350, 300); 
      text(tempInterest, xText+70, yText+20, 350, 300);
      text(tempCoverage, xText+70, yText+40, 350, 300);
   
      fill(255);
      textFont(font_bold); 
      text("Inspect This Meme!", xText+10, yText+68, 350, 300);
    //text(all_terms, xText+50, yText+50, 350, 300);
    }
    
    else {
      rectMode(CORNER);
      textFont(font); 
      fill(0);
      text("Unsuccessfull News Item", xText+10, yText+10);  
      text("headline:", xText+10, yText+30); 

      fill(100);
      text(isNews_headline, xText+70, yText+20, 400, 300);

    }//if it is just news
    
    //now give it a time out so it will go away eventually
    selected = (selected-1);
    selected = constrain(selected, 0, 1000);
    if (selected == 1) {somethingSelected = false;} //right before turning off, get the system ready to select something else if it hasn't already.
    
      //println (selected);
  }//end if
  
}//end top render

//for testing only  
public void printContents() {
    //for testing, print out previousTermScores
     print (termName + ": ");
     for (int x = 0; x < termScores.length; x++) { print(termScores[x] + "-");}
     println("");
}//end Printcontents  



public void cleanup() {
    //int runningTotal = 0;
    int maxDiff = 0;
   
    //Cycle through everything
     for (int i = 0; i<=lastTermScores.length-1; i++) {
       
       //first we want to get the total before we resize everything.  Otherwise stuff will be random
        termTotal = termTotal + (termScores[i] - lastTermScores[i]);
        
        //while we're here...make sure you're dealing with !isNews
        if ((termTotal > maxMemeNumber) && (!isNews)) {maxMemeNumber = termTotal; maxMeme = termName;} //somaday change this to longest, not biggest!!! 
       
       //Now, let's resize everything.  I'm unsure why I have to constrain these.
       termScores[i] = constrain(PApplet.parseInt(map(termScores[i], 0, 920, sineArray[i], height)),0, height-sineArray_bottom[i]);
       lastTermScores[i] = constrain(PApplet.parseInt(map(lastTermScores[i], 0, 920, sineArray[i], height)),0, height-sineArray_bottom[i]);
       
       //now get the new difference so we can place the box correctly
       int temp = termScores[i] - lastTermScores[i];  //this is the actual height at each hour (without news)
       //runningTotal = runningTotal + temp;
       
       if (temp >= maxDiff) {
         maxDiff = temp;
         yPointer = termScores[i] - temp/2;
         xPointer = PApplet.parseInt(map (i, 0, termScores.length-1, 0, width));
         
         //set the box height - depending on if this is news or not.
         int boxHeight;
         if (!isNews) {boxHeight = 150;}
         else {boxHeight = 100;}
         
         //xbox is either above, below, to the right, or to the left of xyPointer by 100 px, depending on the quadrant
         //also set the point at which to start text
         if (xPointer <= width/2) {xBox = xPointer+50; xBox1 = xPointer+150+constrain(boxWidth*6, 140, 1000); xText = xBox+5; xLink = xBox1-10;}   //if it's on the righ side
         else{ xBox = xPointer-50; xBox1 = xPointer-150-constrain(boxWidth*6, 140, 1000); xText = xBox1+5; xLink = xBox-10;} //if its on the left

         if (yPointer <= height/2) {yBox = yPointer+50; yBox1 = PApplet.parseInt(yPointer+boxHeight); yText = yBox + 6;}   //if it's on the top
         else{ yBox = yPointer-50; yBox1 = PApplet.parseInt(yPointer-boxHeight); yText = yBox1 +6;}  //if its on the bottom  
       }
       
     }//end for
      
      //one more thing to do - we have to make the newsTotal for each item! 
      for (int i = 0; i<=interval-1; i++) {
          if (newsArray[i].newsExists==true) { 
              newsTotal = newsTotal + newsArray[i].Score;
          }//end if
      }//end for
      
       float temp = 1;
       
        //before we do anything else, check the news score and update maxFertelized and maxFertelizedNumber
         if ((newsTotal > maxFertelizedNumber) && (!isNews)) {maxFertelizedNumber = newsTotal; maxFertelized = termName;} 
       
       //White: When news is lacking compared to intrest (news_lacking = true)
       if (termTotal >= newsTotal) {  
         temp = newsTotal*100/termTotal; 
         news_Lacking = true; 
         myColor = PApplet.parseInt(map(constrain(temp, 0, 5), 0, 5, 255, 140));
         percentageCovered = temp; 
        //println (temp); 
        
        //one more thing
        if (temp <= 2.0f) {suggestion = suggestion + " \n" + termName;}  //now make it so this has five max
     }
     
     //when there's already too much news
       else { 
          temp = termTotal*100/newsTotal;  
          myColor = PApplet.parseInt(map(constrain(temp, 0, 15), 0, 15, 140, 0)); 
          percentageCovered = temp;  
   }
       //println(percentageCovered + " " + news_Lacking) ;
       //println("TERMS: " + termTotal + " COVERAGE: " + newsTotal + " SO: " + temp + "%" + "AND NEWS LACKING= " + news_Lacking);  

 }//end cleanup  
  
}

  //for some reason these have to be super global
  int[] sineArray; 
  int[] sineArray_bottom;

class TermSystem {

  ArrayList terms;    // An arraylist for all the particles

  TermSystem() {
    
    //before anything else, calculate the array of sine values to start at
    sineArray = new int[interval]; 
    sineArray_bottom = new int[interval]; 
    calculateSine();
    
    //now let's get this show on the road.  Start by initializing the hell out of everything
    println("Making a term system");
    terms = new ArrayList();              // Initialize the arraylist that will hold all term objects
    
    int[] previousTermScores = new int[interval];  //this is to hold the previous scores and add it to the current one
    for (int i = 0; i < previousTermScores.length; i++) { previousTermScores[i] = 0;}//initialize it with 0's.  
    String currentName = null; //this will hold the terms we are currently on
  
    //Go through each item and, if this is a new term, add it.  If it's not, add the rank to its info  
    for (int i = 0; i < name.length; i++) {  //for every item in the doner list
   
        if ((name[i].equals(currentName)) == false) {  //this is the first time we've seen this term
              //println ("New item with name " + name[i]);
               //get the last item's score array to use in the new Term
              if(terms.size() >= 1){
                Term t = (Term) terms.get(terms.size()-1);
                arraycopy(t.termScores, previousTermScores);  
                t.cleanup(); //clean the last one, since it means we must be done with that one.  We must find a way to do this to the last one!
              }//end second if
              
              //create the new item.  Let's add in some news information now
              //if (boolean(is_news[i]) == false) {
                terms.add(new Term(PApplet.parseInt(order[i]), name[i], PApplet.parseInt(score[i]), previousTermScores, all_terms[i], is_news[i], has_news[i], news_headline[i], PApplet.parseInt(news_score[i]), news_category[i], term_history[i]));
                currentName =  name[i];   //save the name so we know if this is a new term or a continuation
              //}//end test if
      
    }//end if it's the first one
        
        else { //it's the second or third or fourthone!
              
              //println ("Duplicate item, "+  name[i]);
              Term t = (Term) terms.get(terms.size()-1);
              
              //println("OLD ITEM");
              t.insertNews(PApplet.parseBoolean(has_news[i]), PApplet.parseInt(order[i]), news_headline[i], PApplet.parseInt(news_score[i]), news_category[i]);
              
              t.insertScore(PApplet.parseInt(score[i]), PApplet.parseInt(order[i]), term_history[i]);
              
        }//end else
     }//end for
     
     //You're done!  Now you must "clean up" the very last item in that list, becuase it never got a chance to!
     Term t = (Term) terms.get(terms.size()-1);
     t.cleanup();
     
  }//end constructor
  
  
public void display () {

  //first, let's render some underNews!  that is to say, if (isNews == true) {  
   if (showNews) {
        for (int i = 0; i <= terms.size()-1; i++) { 
          //for (int i = 0; i <=4 ; i++) {  //for testing only
            Term t = (Term) terms.get(i);
            if (t.isNews == true) {t.isNewsRender();}
          
        }//end for
    }//end if
  
    //Now let's render the terms!
    for (int i = 0; i <= terms.size()-1; i++) { 
      //for (int i = 0; i <=4 ; i++) {  //for testing only
        Term t = (Term) terms.get(i);
        if (t.isNews == false) {t.render();}
       //t.newsRender
    }//end for
    
    //now go through and display any stuff that should be rendered on top
     for (int i = 0; i <= terms.size()-1; i++) { 
      //for (int i = 0; i <=50 ; i++) {  //for testing only
        Term t = (Term) terms.get(i);
        //t.printContents();
        t.topRender();
    }//end for
    
}//end display  
  
public void highlight() {

  float mappedNo = map(mouseX, 0, width, 0, interval-1);
  int floorNo =floor(mappedNo);
  int ceilNo =ceil(mappedNo);
  //println(mouseX + " MAPS TO " +  mappedNo + " WHICH IS BETWEEN " + floorNo + " AND " + ceilNo);
  
  //Calculate out the X values for floor and ceil
  int floorX = PApplet.parseInt(map (floorNo, 0, interval-1, 0, width));
  int ceilX = PApplet.parseInt(map (ceilNo, 0, interval-1, 0, width));
  
  //Itterate through the arraylist 
  for (int i = 0; i <= terms.size()-1; i++) { 
      //for (int i = 0; i <=50 ; i++) {  //for testing only
       Term t = (Term) terms.get(i);
       
       //highY
       int slope = (t.termScores[ceilNo] - t.termScores[floorNo])/(ceilX-floorX);
       int yIntersect = t.termScores[floorNo] - (slope*floorX);
       int highY = (slope*mouseX) + yIntersect;
       
       //LowY
       int slope1 = (t.lastTermScores[ceilNo] - t.lastTermScores[floorNo])/(ceilX-floorX);
       int yIntersect1 = t.lastTermScores[floorNo] - (slope1*floorX);
       int lowY = (slope1*mouseX) + yIntersect1;
       
       if ((mouseY <= highY) && (mouseY >= lowY)) {
           //println (t.percentageCovered + " " + t.news_Lacking + " " + t.myColor);
           //println (t.termName);
           //println (mouseX + " top: " + highY + " AND bottom: " + lowY);
           
             //note - if it finds something, check if somethingSelected.  If it isyes, go to currentSelected and turn its counter to 0
            if (somethingSelected) {Term old = (Term) terms.get(currentSelected); old.selected = 0; } 
            currentSelected = i;
            somethingSelected = true;  
            
           //finally set the timer on t
            t.selected = 20;  //which is the whole point of this function
       }//end if
    }//end for
}  //end hilight




//this is a function that's called whenever there's a click and somethingSelected.  
//It checks if someone wants to inspect a meme.  If not, it calls highlight() to see if someone wants to highlight a meme
public void inspect() {
 
  Term selected = (Term) terms.get(currentSelected);
  if ((mouseX > selected.xText+5) && (mouseX < selected.xLink) && (mouseY > selected.yText+60) && (mouseY < selected.yText+85)) {
     println ("i want meme!");
     inspecting = true;
  
     //make secondary navigator's dates equal to this.  
      int[] tempScores = new int[interval];
      int startNumber = 0;
      int stopNumber = interval-1;
      boolean alreadyStarted = false;
      boolean alreadyFinished = false;
      
      //first get the actual numbers
      for (int i = 0; i < interval; i++) {
         tempScores[i] = selected.termScores[i]-selected.lastTermScores[i];
         //println (tempScores[i]);
      }
      
      //now get the start and stop
      for (int i = 0; i < interval; i++) {
         if ((tempScores[i] == 0) && (alreadyStarted == false)) {startNumber = i; }
         //if (tempScores[i] == 0) {startNumber = i+1; }
         else {alreadyStarted = true;}
         //println (i + " " + tempScores[i] + " STARTED AT " + startNumber);
      }
    
      for (int x = interval-1; x >= 0; x--) {
         if ((tempScores[x] == 0) && (alreadyFinished == false)) {stopNumber = x; }
         else {alreadyFinished = true;}
      }
      //you've got the information, now use it to make the bottom and top! 
      secondaryNavBar.inspectorDate = subset(date, startNumber, stopNumber-startNumber+1);
      secondaryNavBar.initializeInspector(); //Create the bottom array, get arraylist ready

      //now let's set some more variables!
      secondaryNavBar.termHistory = subset(selected.termHistory, startNumber, stopNumber-startNumber+1);
      secondaryNavBar.localInterval = secondaryNavBar.inspectorDate.length; //set the interval there.  it will be usefull.
      secondaryNavBar.isNews = selected.isNews;
      secondaryNavBar.myColor = selected.myColor;
      secondaryNavBar.secondaryName = selected.termName;
      secondaryNavBar.termTotal= selected.termTotal;
      secondaryNavBar.percentageCovered= selected.percentageCovered;
      secondaryNavBar.news_Lacking=selected.news_Lacking;
      secondaryNavBar.contributingTerms = ""; //make this 0 again
      
      //Now here's where we want to bring in the news!  
      //iterate through those numbers of Selected.
       int itterationCounter = 0; //simple way of keeping track what cell we're on
       for (int z = startNumber; z <= stopNumber; z++) {
          if (selected.newsArray[z].newsExists == true){
            //println(itterationCounter + " has news");
            secondaryNavBar.addNews(selected.newsArray[z].Headline, selected.newsArray[z].Category, selected.newsArray[z].Score, itterationCounter);//get the order
          }//end if
          itterationCounter++;
        }//end for
      
      //Allright, now call a function in secondaryNavBar that populates the submemes from TermHistory
      secondaryNavBar.fillSubMemes();
 
      //for testing
      //for (int z = 0; z < secondaryNavBar.localInterval; z++) {
        //print(secondaryNavBar.inspectorOverallTerm[z] + " " );
        //println (z);
      //}
  }//end if
  
  else {termSystem.highlight();}  //they didn't want a meme.
}//end inspect




public void calculateSine() {
 //fill values into sineArray
  float xoff = 0.1f;
  float a = 0.3f;
  float inc = TWO_PI/15.0f;

    for(int i=0; i < sineArray.length; i=i+1) {
        xoff = xoff + 50;
        a = a + inc;
        int temp = PApplet.parseInt((noise(xoff))*125);
        //temp =temp + int(100+sin(a)*50.0);
        sineArray[i] = constrain(temp, 50, height)+40; //play with the 100
  }//end for

  
}//calculate Sine


}//end object





  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "Current62" });
  }
}
